%define repodir %{_javadir}/repository.jboss.com/qdox/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define with_maven 1
%define with_repolib 1

Name:          qdox16
Version:       1.6.3
Release:       %mkrel 1
Summary:       Extract class/interface/method definitions from sources
Group:         Development/Java
License:       ASL 2.0
URL:           http://qdox.codehaus.org/
# svn export https://svn.codehaus.org/qdox/tags/QDOX_1_6_3/ qdox-1.6.3
# tar czvf qdox-1.6.3-src-svn.tar.gz qdox-1.6.3
Source0:       qdox-1.6.3-src-svn.tar.gz
Source1:       qdox-1.6.3-autogeneratedfiles.tar.gz
Source2:       component-info3.xml
# circular dependecy
#Source5:       http://www.ibiblio.org/maven//jmock/jars/jmock-1.0.0.jar
Patch0:        qdox-1.6.2-lexer_flex.patch
Patch1:        qdox-1.6.3-pom_xml.patch
Patch2:        qdox-1.6.3-jflex-plugin.patch

BuildRequires: ant
BuildRequires: ant-junit
%if %with_maven
BuildRequires: maven2
BuildRequires: maven-ant-plugin
BuildRequires: maven-antrun-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-dependency-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-jflex-plugin
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-project-info-reports-plugin
BuildRequires: maven-release-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-surefire-plugin
%endif
BuildRequires: byaccj
BuildRequires: java-devel
BuildRequires: java_cup
BuildRequires: jflex
BuildRequires: jmock1
BuildRequires: jpackage-utils
BuildRequires: junit
BuildRequires: java-1.5.0-gcj-devel
Requires:      jpackage-utils
BuildArch:     noarch

%description
QDox is a high speed, small footprint parser for
extracting class/interface/method definitions
from source files complete with JavaDoc @tags.
It is designed to be used by active code
generators or documentation tools.

%package javadoc
Group:          Development/Java
Summary:        Javadoc for %{name}

%description javadoc
Extract class/interface/method definitions from sources

This package contains documentation for %{name}.

%if %with_repolib
%package repolib
Group:         Development/Java
Summary:       Artifacts to be uploaded to a repository library

%description repolib
Extract class/interface/method definitions from sources

This package contains artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep

%setup -q -n qdox-%{version}
%patch0 -p1
%patch1 -p0
%patch2 -p0
rm -rf bootstrap/*
%if !%with_maven

tar xf %{SOURCE1}
cp -pr pom.xml target/classes/META-INF/maven/com.thoughtworks.qdox/qdox

mkdir -p lib
pushd lib
  ln -sf $(build-classpath ant) ant-1.5.1.jar
  ln -sf $(build-classpath junit) junit-3.8.1.jar
  ln -sf $(build-classpath jmock1) jmock-1.0.0.jar
#  cp %{SOURCE5} .
popd
rm -rf src/test/com/thoughtworks/qdox/JavaDocBuilderTest.java
%else
	ln -s %{_bindir}/byaccj bootstrap/yacc.linux
	ln -s %{_bindir}/byaccj bootstrap/yacc.linux.x86_64
	ln -s $(build-classpath jflex) bootstrap
%endif

%build
export JAVA_HOME=%{_jvmdir}/java-1.5.0
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
%if %with_maven

  mvn-jpp \
    -e \
    -Dmaven.test.failure.ignore=true \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    ant:ant install javadoc:javadoc

%else

  mkdir temp
  pushd temp
  export CLASSPATH=$(build-classpath java_cup jflex junit ant/ant-junit jmock1):target/classes:target/test-classes
  $JAVA_HOME/bin/java JFlex.Main -d . ../src/grammar/lexer.flex
  %{_bindir}/byaccj \
      -Jnorun \
      -Jnoconstruct \
      -Jclass=Parser \
      -Jsemantic=Value \
      -Jpackage=com.thoughtworks.qdox.parser.impl \
      ../src/grammar/parser.y
  popd

  mv temp src/java/com/thoughtworks/qdox/parser/impl

  ant \
    -Dmaven.repo.local=$PWD \
    -Duser.home=$PWD \
    -Dbuild.sysclasspath=only \
    jar javadoc

%endif

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

mkdir -p %{buildroot}%{_javadir}
install -m 644 target/qdox-%{version}.jar \
  %{buildroot}%{_javadir}/qdox16.jar

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-qdox16.pom
%add_maven_depmap JPP-qdox16.pom qdox16.jar

mkdir -p %{buildroot}%{_javadocdir}/qdox16
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/qdox16

mkdir -p %{buildroot}%{repodir}
mkdir -p %{buildroot}%{repodirlib}
install -m 644 %{SOURCE2} %{buildroot}%{repodir}/component-info.xml
tag=`echo qdox-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@NAME@/qdox-component-info/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@ID@/qdox/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@LICENSE@/%{license}/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s|@PROJECTHOME@|%{url}|g" %{buildroot}%{repodir}/component-info.xml
sed -i "s|@DESCRIPTION@|Extract class/interface/method definitions from sources.|g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@ARTIFACTID@/qdox.jar/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@INCLUDEINPUT@/qdox.jar/g" %{buildroot}%{repodir}/component-info.xml
mkdir -p %{buildroot}%{repodirsrc}
install -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}/
install -m 644 %{PATCH0} %{buildroot}%{repodirsrc}/
install -m 644 %{PATCH1} %{buildroot}%{repodirsrc}/
install -m 644 %{PATCH2} %{buildroot}%{repodirsrc}/
cp %{buildroot}%{_javadir}/qdox16.jar %{buildroot}%{repodirlib}/qdox.jar

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%{_javadir}/qdox16.jar
%{_mavendepmapfragdir}/*
%{_mavenpomdir}/*
%doc *.txt

%files javadoc
%{_javadocdir}/qdox16

%if %with_repolib
%files repolib
%defattr(-,root,root)
%{repodir}
%endif



%changelog
* Fri Aug 05 2011 dmorgan <dmorgan> 1.6.3-1.mga2
+ Revision: 131948
- Clean spec file
- Fix buildrequires

  + gil <gil>
    - imported package qdox16


* Sat Mar 26 2011 gil <puntogil@libero.it> 1.6.3-4mamba
- rebuilt with java-gcj-compat support

* Thu Nov 04 2010 gil <puntogil@libero.it> 1.6.3-3mamba
- rebuilt devel

* Mon Nov 16 2009 gil <puntogil@libero.it> 1.6.3-2mamba
- added new sub package: repolib

* Thu Jul 30 2009 gil <puntogil@libero.it> 1.6.3-1mamba
- update to 1.6.3

* Sat Jun 27 2009 gil <puntogil@libero.it> 1.6.2-1mamba
- uodate to 1.6.2

* Mon Mar 02 2009 gil <puntogil@libero.it> 1.6.1-1mamba
- package created by autospec
